/**
 * Created by Kevin on 18.06.2016.
 */

window.onresize = function () {
    windowWidth = window.innerWidth;
    windowHeight = window.innerHeight;
    rtime = new Date();
    if (!rtimeout) {
        rtimeout = true;
        document.getElementById("backgroundEffect").style.opacity = 0;
        setTimeout(resizeend, 1500);
    }

};

function resizeend() {
    if (new Date() - rtime < 1500) {
        setTimeout(resizeend, 100);
    } else {
        rtimeout = false;
        setupScreen();
    }
}

function renderLoop() {
    renderer.render(stage);
    setTimeout(renderLoop, 40);
}

function setupScreen() {
    delete window.renderer;
    renderer = PIXI.autoDetectRenderer(windowWidth, windowHeight, {transparent: true});
    document.getElementById("backgroundEffect").innerHTML = "";
    document.getElementById("backgroundEffect").appendChild(renderer.view);
    renderer.view.position = "fixed";
    stage = new PIXI.Container();

    drawStars();
    new Constellation();

    document.getElementById("backgroundEffect").style.opacity = 1;
}

function drawStars() {
    stars = [];
    var max = Math.sqrt(windowHeight * windowWidth);
    for (var i = 0; i < max; i++) {
        stars.push(new Star());
    }
}

function Star() {
    var prop = {
        star: new PIXI.Sprite(starTexture),
        xPos: Math.random() * windowWidth,
        yPos: Math.random() * windowHeight,
        size: Math.random() * (windowHeight / 30),
        xMov: Math.random() - 0.5,
        yMov: Math.random() - 0.5
    };

    prop.star.anchor.x = 0.5;
    prop.star.anchor.y = 0.5;
    prop.star.position.x = prop.xPos;
    prop.star.position.y = prop.yPos;
    prop.star.height = prop.size;
    prop.star.width = prop.size;
    stage.addChild(prop.star);

    starLoop();

    function starLoop() {
        prop.xPos = prop.xPos + prop.xMov;
        prop.yPos = prop.yPos + prop.yMov;
        prop.star.position.x = prop.xPos;
        prop.star.position.y = prop.yPos;
        if (prop.xPos > windowWidth + 10) {
            prop.xPos = -10;
        } else if (prop.xPos < -10) {
            prop.xPos = windowWidth + 10;
        }
        if (prop.yPos > windowHeight + 10) {
            prop.yPos = -10;
        } else if (prop.yPos < -10) {
            prop.yPos = windowHeight + 10;
        }
        setTimeout(starLoop, 100);
    }

    this.getProp = function () {
        return prop;
    }
}

function Constellation() {
    var prop = {
        graphics: new PIXI.Graphics(),
        inConstellation: [],
        notInConstellation: []
    };

    refreshConstellation();
    stage.addChild(prop.graphics);

    function refreshConstellation() {
        var starProp;
        var range = Math.sqrt(windowHeight * windowWidth) / 10;
        for (var i = 0; i < stars.length; i++) {
            starProp = stars[i].getProp();
            if (mouse.y - range < starProp.yPos && starProp.yPos < mouse.y + range && mouse.x - range < starProp.xPos && starProp.xPos < mouse.x + range) {
                if (prop.inConstellation.indexOf(i) < 0 && prop.notInConstellation.indexOf(i) < 0) {
                    if (Math.random() > 0.8) {
                        prop.inConstellation.push(i);
                    } else {
                        prop.notInConstellation.push(i);
                    }
                }
            } else if (prop.inConstellation.indexOf(i) > -1) {
                prop.inConstellation.splice(prop.inConstellation.indexOf(i), 1);
            } else if (prop.notInConstellation.indexOf(i) > -1) {
                prop.notInConstellation.splice(prop.notInConstellation.indexOf(i), 1);
            }
        }

        prop.graphics.clear();
        prop.graphics.lineStyle(1, 0x808080, 0.3);
        for (var i2 = 0; i2 < prop.inConstellation.length; i2++) {
            if (i2 == 0) {
                prop.graphics.moveTo(stars[prop.inConstellation[i2]].getProp().xPos, stars[prop.inConstellation[i2]].getProp().yPos)
            } else {
                prop.graphics.lineTo(stars[prop.inConstellation[i2]].getProp().xPos, stars[prop.inConstellation[i2]].getProp().yPos)
            }
        }
        setTimeout(refreshConstellation, 50);
    }
}

window.onmousemove = function (event) {
    mouse.x = event.clientX;
    mouse.y = event.clientY;
};

var rtime;
var rtimeout = false;

var windowWidth = window.innerWidth;
var windowHeight = window.innerHeight;
var mouse = {x: 0, y: 0};
var renderer;
var stage;
var stars;
var starTexture = PIXI.Texture.fromImage("Star.png");

setupScreen();
setTimeout(renderLoop, 100);